博客
关于我
强烈建议你试试无所不能的chatGPT,快点击我
POJ - 3723 Conscription(最大生成树Kruskal)
阅读量:5099 次
发布时间:2019-06-13

本文共 2540 字,大约阅读时间需要 8 分钟。

Conscription
Time Limit: 1000MS   Memory Limit: 65536K
Total Submissions: 13061   Accepted: 4581

Description

Windy has a country, and he wants to build an army to protect his country. He has picked up N girls and M boys and wants to collect them to be his soldiers. To collect a soldier without any privilege, he must pay 10000 RMB. There are some relationships between girls and boys and Windy can use these relationships to reduce his cost. If girl x and boy y have a relationship d and one of them has been collected, Windy can collect the other one with 10000-d RMB. Now given all the relationships between girls and boys, your assignment is to find the least amount of money Windy has to pay. Notice that only one relationship can be used when collecting one soldier.

Input

The first line of input is the number of test case.

The first line of each test case contains three integers, NM and R.
Then R lines followed, each contains three integers xiyi and di.
There is a blank line before each test case.

1 ≤ NM ≤ 10000

0 ≤ R ≤ 50,000
0 ≤ xi < N
0 ≤ yi < M
0 < di < 10000

Output

For each test case output the answer in a single line.

Sample Input

25 5 84 3 68311 3 45830 0 65920 1 30633 3 49751 3 20494 2 21042 2 7815 5 102 4 98203 2 62363 1 88642 4 83262 0 51562 0 14634 1 24390 4 43733 4 88892 4 3133

Sample Output

7107154223

Source

, windy7926778

[]   [Go Back]   []   []

听到别人说Kruskal算法,然而我并不知道这是什么东西(TAT),赛后发现就是并查集加上一个函数。(QAQ脑补)

题目大意:有一个城镇要组织军队,招收N名女人和M名男人,原本每人费用10000元,但如果女人和男人有关系d且其中一个已经被招收,则另外一个只需要10000-d元,求出需要最少的招收费用。

思路:用一个结构体存下某种关系,因为要使得花费最少,所以d要从大到小排一下序,然后用两个集合i-x和i-y建立并查集,表示x和y其中一个已经被招收,一个没有被招收,然后求和把d加起来,再把x和y组合。最后用原总费用减去sum即可。这次又差一点忘了数组开两倍,一次CE,原因init初始值的函数写的int类型,但没有返回值(TAT)

附上AC代码:

#include
#include
#include
#include
using namespace std;const int maxn=10000;int par[maxn*2+10];int N,M,R;struct army{int women,man,money;};bool cmp(const army a,const army b){ return a.money>b.money;}void init(){ for(int i=0;i<=2*maxn;i++) par[i]=i;}int find(int a){ if(a==par[a]) return a; else return par[a]=find(par[a]);}void unite(int a,int b){ a=find(a); b=find(b); if(a==b)return ; par[a]=b;}bool same(int a,int b){ return find(a)==find(b)?true:false;}int main(){ int T; vector
v; scanf("%d",&T); while(T--) { army ar; int sum_m=0; scanf("%d%d%d",&N,&M,&R); init(); v.clear(); for(int i=0;i

转载于:https://www.cnblogs.com/l1832876815/p/6771149.html

你可能感兴趣的文章
基本封装方法
查看>>
[Typescript] Specify Exact Values with TypeScript’s Literal Types
查看>>
Illustrated C#学习笔记(一)
查看>>
理解oracle中连接和会话
查看>>
Scrapy实战篇(三)之爬取豆瓣电影短评
查看>>
HDU 5510 Bazinga KMP
查看>>
[13年迁移]Firefox下margin-top问题
查看>>
Zookeeper常用命令 (转)
查看>>
Bootstrap栅格学习
查看>>
程序员的数学
查看>>
聚合与组合
查看>>
洛谷 P2089 烤鸡【DFS递归/10重枚举】
查看>>
我眼中的技术地图
查看>>
lc 145. Binary Tree Postorder Traversal
查看>>
在centos上开关tomcat
查看>>
android dialog使用自定义布局 设置窗体大小位置
查看>>
ionic2+ 基础
查看>>
[leetcode]Minimum Path Sum
查看>>
Aizu - 1378 Secret of Chocolate Poles (DP)
查看>>
csv HTTP简单表服务器
查看>>